package com.cohomefinder.gwt.mortgagecalculator.client;

import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.ClickListener;
import com.google.gwt.user.client.ui.DialogBox;
import com.google.gwt.user.client.ui.FlexTable;
import com.google.gwt.user.client.ui.HasVerticalAlignment;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.KeyboardListenerAdapter;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.PopupPanel;
import com.google.gwt.user.client.ui.RootPanel;
import com.google.gwt.user.client.ui.TextBox;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.user.client.ui.Widget;

/**
 * Copyright 2006 Colorado HomeFinder
 */
public class MortgageCalc implements EntryPoint {

/*	public static TextBox getNumericOnlyTextBox() {
		TextBox tb = new TextBox();
		tb.addKeyboardListener(new KeyboardListenerAdapter() {
	        public void onKeyPress(Widget sender, char keyCode, int modifiers) {
	          if (!Character.isDigit(keyCode)) {
	            // TextBox.cancelKey() suppresses the current keyboard event.
	            ((TextBox)sender).cancelKey();
	          }
	        }
	      });
		return tb;
	}
	*/
	
  /**
   * This is the entry point method.
   */
  public void onModuleLoad() {


	final FlexTable ft = new FlexTable();

	final Label amountLabel = new Label("Loan Amount");
    final TextBox amount = new TextBox();
    ft.setWidget(0,0, amountLabel);
    ft.setWidget(0,1, amount);
    
    final Label interestLabel = new Label("Interest Rate");
    final TextBox interest = new TextBox();
    interest.setText("6.25");
    ft.setWidget(1,0,interestLabel);
    ft.setWidget(1,1,interest);
    
    final Label yearsLabel = new Label("Years");
    final TextBox years = new TextBox();
    years.setText("30");
    ft.setWidget(2,0,yearsLabel);
    ft.setWidget(2,1,years);
  
    final Button calculate = new Button("Calculate");    
    ft.setWidget(3,0,calculate);

    final Label numPaymentsLabel = new Label("Number of Payments");
    final TextBox numPayments = new TextBox();
    numPayments.setEnabled(false);
    numPayments.setStyleName("mtgcalc-textbox");
    ft.setWidget(4,0,numPaymentsLabel);
    ft.setWidget(4,1,numPayments);
    
    final Label paymentLabel = new Label("Payment");
    final TextBox payment = new TextBox();
    payment.setEnabled(false);
    payment.setStyleName("mtgcalc-textbox");
    ft.setWidget(5,0,paymentLabel);
    ft.setWidget(5,1,payment);

    final Label errorLabel = new Label("");
    errorLabel.setStyleName("reqd");
    errorLabel.setVisible(false);
  
    calculate.addClickListener(new ClickListener() {
      public void onClick(Widget sender) {
    	  
    	  int retVal = calculatePmt(years,amount,interest,numPayments,payment);
      	  if (retVal != 0) {
		errorLabel.setText("Please enter year, amount and interest rate as numbers");
    		errorLabel.setVisible(true);
    	  } else {
    		errorLabel.setVisible(false);
	  }
      }
    });
   

    VerticalPanel vp = new VerticalPanel();

    vp.add(ft);
    vp.add(errorLabel);

    RootPanel.get("slot1").add(vp);
  }
  
  private int calculatePmt(TextBox years, TextBox amount, TextBox interest, TextBox numPayments, TextBox payment) {
	  int iYears = -1;
	  try {
		  iYears = Integer.parseInt(years.getText());
	  } catch (NumberFormatException ignore) {}
	  int iAmount = -1;
	  try {
		  iAmount = Integer.parseInt(amount.getText());
	  } catch (NumberFormatException ignore) {}
	  float fInterest = -1f;
	  try {
		  fInterest = Float.parseFloat(interest.getText());
	  } catch (NumberFormatException ignore) {}
	  if (iYears < 0 || iAmount < 0 || fInterest < 0) {
		  return -1;
	  }
	  fInterest = fInterest/(12*100); // 12 because we need a monthly interest rate, 100 because we are handed 5% when it should be 0.05
	  
	  int iNumPayments = 12* iYears;
	  double dPayment = (iAmount * fInterest) / (1 - Math.pow(1+fInterest, -1*iNumPayments));
	  dPayment = (Math.round(dPayment*100))/100d;
	 
	  numPayments.setText(String.valueOf(iNumPayments));
	  payment.setText(String.valueOf(dPayment));
	  
	  return 0;
}
  
  private static class ErrorDialog extends DialogBox implements ClickListener{

	    public ErrorDialog(final String msg) {
	      super();
	      setText("Error");
	      VerticalPanel vp = new VerticalPanel();
	      vp.add(new Label(msg));
	      vp.add(new Button("Close", this));
	      this.add(vp);
	    }

		public void onClick(Widget sender) {
			hide();
		}
	  }
}
